<template>
  <div class="vlue-content-component-image-with-text" :style="getImageStyle()">
    <div class="vlue-content-component-image-with-text-overlay"
      :style="{ background: props.overlayColor }">
    </div>
    <h3 :style="getTextStyle()">
      {{props.text}}
    </h3>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  props: {
    props: Object,
  },
  methods: {
    getImageStyle() {
      return {
        'background-image' : (this.props.src ? 'url(' + this.props.src + ')' : undefined),
        'background-color' : this.props.bgcolor,
        'height'           : this.props.height,
      };
    },
    getTextStyle() {
      return {
        'color'       : this.props.textColor,
        'font-size'   : this.props.fontSize,
        'font-family' : this.props.font?.split('.')[0],
      }
    }
  },
  mounted() {
    // component properties with types and default values
    this.$emit('mounted', [
      {
        name: 'src',
        type: 'image',
        value: null, // image type prop will default to first image in images folder
      },
      {
        name: 'height',
        type: 'textfield',
        value: '200px',
      },
      {
        name: 'overlayColor',
        type: 'color',
        value: 'hsla(320, 50%, 30%, 0.5)',
      },
      {
        name: 'bgcolor',
        type: 'color',
        value: '#0005',
      },
      {
        name: 'text',
        type: 'textarea',
        value: 'may you find peace on this pale blue dot',
      },
      {
        name: 'textColor',
        type: 'color',
        value: 'white',
      },
      {
        name: 'fontSize',
        type: 'textfield',
        value: '30px',
      },
      {
        name: 'font',
        type: 'font',
        value: undefined,
      },
    ]);
  },
})
</script>

<style lang="scss">
.vlue-content-component-image-with-text {
  display: flex;
  justify-content: center;
  align-items: center;
  margin: 10px;
  border-radius: 10px;
  background-size: cover;
  background-position: center;
  box-shadow: 0 5px 7px rgba(0,0,0,0.25);
  overflow: hidden;
  .vlue-content-component-image-with-text-overlay {
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
  }
  h3 {
    z-index: 0;
    text-shadow: 0 5px 5px #000;
  }
}
</style>
